Index: /trunk/SophyaPI/PI/picmap.cc
===================================================================
--- /trunk/SophyaPI/PI/picmap.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/picmap.cc	(revision 4083)
@@ -6,4 +6,5 @@
 #include "picmap.h"
 #include <iostream>
+
 
 //++
@@ -24,9 +25,10 @@
 //--
 
-#define  MXMAPIDS   30
+#define  MXMAPIDS   34
 static   int    MapNCols[MXMAPIDS] = {
   256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
   256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 
-  256, 256, 256, 256, 256, 256, 256, 256, 256, 256  };
+  256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
+  216, 512, 4096, 32768  };
 
 // Tables de couleurs :
@@ -37,4 +39,8 @@
 // 1 Standard PI 64 couleurs differentes
 // 1 Standard PI 16 couleurs
+// 1 Standard PI , 216 couleurs RGB (6x6x6)
+// 1 Standard PI , 512 couleurs RGB (8x8x8)
+// 1 Standard PI , 4096 couleurs RGB (16x16x16)
+// 1 Standard PI , 32768 couleurs RGB (32x32x32)
 
 static   const char*  MapNoms[MXMAPIDS]  = {
@@ -47,5 +53,6 @@
                       "MIDAS_Stairs9","MIDAS_StairCase","MIDAS_Color",
                       "MIDAS_ManyCol","MIDAS_Idl14","MIDAS_Idl15",
-                      "MultiCol16","MultiCol64"};
+ 		      "MultiCol16","MultiCol64",
+                      "RGB216CM","RGB512CM","RGB4096CM","RGB32768CM"};
 
 static   CMapId MapIds[MXMAPIDS] = { 
@@ -58,5 +65,6 @@
                       CMAP_MIDAS_Stairs9, CMAP_MIDAS_StairCase, CMAP_MIDAS_Color, 
                       CMAP_MIDAS_ManyCol, CMAP_MIDAS_Idl14, CMAP_MIDAS_Idl15, 
-                      CMAP_COL16, CMAP_COL64 } ;
+                      CMAP_COL16, CMAP_COL64, 
+                      CMAP_RGB216, CMAP_RGB512, CMAP_RGB4096, CMAP_RGB32768} ;
 
 static   int mColTNums[8192];   // Max 8192 tables differentes pour le moment  
@@ -70,5 +78,6 @@
                                   NULL, NULL, NULL, NULL, NULL,
                                   NULL, NULL, NULL, NULL, NULL, 
-                                  NULL, NULL, NULL, NULL, NULL };
+                                  NULL, NULL, NULL, NULL, NULL,
+                                  NULL, NULL, NULL, NULL };
 
 int  PIColorMap::NumberStandardColorMaps()
@@ -122,6 +131,12 @@
 //|	CMAP_COL64      :  64 Couleurs arcenciel 
 //|	CMAP_OTHER      :  Table non standard 
+//|	CMAP_RGB216     :  216 couleurs, 6x6x6 couleurs en composantes RGB
+//|	CMAP_RGB512     :  512 couleurs, 8x8x8 couleurs en composantes RGB
+//|	CMAP_RGB4096    :  4096 couleurs, 16x16x16 couleurs en composantes RGB
+//|	CMAP_RGB4096    :  32768 couleurs, 32x32x32 couleurs en composantes RGB
+
 //	Toutes les tables de couleurs standard possèdent 256 cellules de couleurs,
-//	contenant 16 ou 32 ou 128 couleurs distinctes.
+//	contenant 16 ou 32 ou 128 (ou 216) couleurs distinctes, 
+//	sauf CMAP_RGB512 , CMAP_RGB4096 et CMAP_RGB32768.
 //
 // PIColorMap(string const& nom, int nCol)
@@ -144,5 +159,6 @@
 
    if (NMaxTableAuto == 0) { //  Il faut allouer les tables de depart
-     if ( TotNbColors() > 4096 ) NMaxTableAuto = MXMAPIDS-1;
+     if ( TotNbColors() >= 4096 ) NMaxTableAuto = MXMAPIDS-2;
+     if ( TotNbColors() >= 65536 ) NMaxTableAuto = MXMAPIDS-1;
      else NMaxTableAuto = 3; 
      //     for(k=0; k<NMaxTableAuto; k++)  { 
@@ -158,5 +174,5 @@
    for(kdx=0; kdx<MXMAPIDS; kdx++)  if (id == MapIds[kdx])  break;
    if (kdx == MXMAPIDS)  { id = MapIds[0];  kdx = 0; }
-   for(k=0; k<NMaxTableAuto; k++) {
+   for(k=0; k<=NMaxTableAuto; k++) {
      if ((MapIds[k] == id) && (mMaps[k] == NULL))  { //  Table pas encore alloue 
        mnom = MapNoms[k]; 
@@ -176,7 +192,12 @@
        if ( mMaps[k] ) {  
          mColTNums[mMaps[k]->mCTId] = 1;  // Je force a liberer les couleurs 
-         delete mMaps[k] ;
+         delete mMaps[k] ;   mMaps[k] = NULL;
+         mnom = MapNoms[k]; 
+         cout << " PIColorMap::PIColorMap(CMapId id) Freeing colors for ColorMap " 
+	      << mnom << " ... " << endl;
        }
        mnom = MapNoms[kdx];
+       cout << " PIColorMap::PIColorMap(CMapId id) Allocating ColorMap " 
+	     << mnom << " ... " << endl;
        mMaps[k] = new PIColorMap(MapIds[kdx],  MapNCols[kdx], mnom); 
      }
@@ -563,4 +584,44 @@
       }
       break;
+
+    case CMAP_RGB216 :
+      i = 0;
+      for(int kb=0; kb<6; kb++) {
+        mycol.blue = (unsigned short)(kb*65535/5);
+        for(int jg=0; jg<6; jg++) { 
+          mycol.green = (unsigned short)(jg*65535/5);
+          for(int ir=0; ir<6; ir++) {
+            mycol.red = (unsigned short)(ir*65535/5);
+            AllocColor(mycol, i);   i++;
+          }
+        }            
+      }
+      mycol.blue = mycol.green =  mycol.red = 65535;
+      for(i=216; i<256; i++)
+        AllocColor(mycol, i);
+      break;
+
+    case CMAP_RGB512 :
+    case CMAP_RGB4096 :
+    case CMAP_RGB32768 :
+      {
+      int nlev = 8;
+      if (mType == CMAP_RGB4096)  nlev = 16;
+      else if (mType == CMAP_RGB32768)  nlev = 32;
+      int drgb = 65535/(nlev-1);
+      i = 0;
+      for(int kb=0; kb<nlev; kb++) {
+        mycol.blue = (unsigned short)(kb*drgb);
+        for(int jg=0; jg<nlev; jg++) { 
+          mycol.green = (unsigned short)(jg*drgb);
+          for(int ir=0; ir<nlev; ir++) {
+            mycol.red = (unsigned short)(ir*drgb);
+            AllocColor(mycol, i);   i++;
+          }
+        }            
+      }
+      }
+      break;
+
 //----------------------------------------------------------
 //----------------------------------------------------------
Index: /trunk/SophyaPI/PI/picmap.h
===================================================================
--- /trunk/SophyaPI/PI/picmap.h	(revision 4082)
+++ /trunk/SophyaPI/PI/picmap.h	(revision 4083)
@@ -47,6 +47,11 @@
 
  //  Table simple a 16/64 couleurs 
- CMAP_COL16       = 998,        // 16 Couleurs arcenciel
- CMAP_COL64       = 999         // 64 Couleurs differentes
+ CMAP_COL16       = 991,        // 16 Couleurs arcenciel
+ CMAP_COL64       = 992,         // 64 Couleurs differentes
+ // Table de couleurs RGB 6x6x6=216 couleurs
+ CMAP_RGB216      = 993,        // 216 couleurs avec toutes les nuances RGB
+ CMAP_RGB512      = 994,        // 512 couleurs avec toutes les nuances RGB
+ CMAP_RGB4096     = 995,        // 4096 couleurs avec toutes les nuances RGB
+ CMAP_RGB32768    = 996         // 32768 couleurs avec toutes les nuances RGB
  };
 
Index: /trunk/SophyaPI/PI/picmapview.cc
===================================================================
--- /trunk/SophyaPI/PI/picmapview.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/picmapview.cc	(revision 4083)
@@ -5,5 +5,7 @@
 #include "sopnamsp.h"
 #include "picmapview.h"
+#include "strutil.h"
 #include <math.h>
+#include <iostream>
 
 //++
@@ -79,5 +81,8 @@
   if ( cmap && (cmp->Type() == cmap->Type()) && (cmp->Type() != CMAP_OTHER)
        && (cmp->IsColorIndexReversed() == cmap->IsColorIndexReversed())
-       && (fabs(vmin-min) < 1.e-69)  && (fabs(vmax-max) > -1.e-69) )  return;
+       && (fabs(vmin-min) < 1.e-69)  && (fabs(vmax-max) > -1.e-69) )  { 
+    if (refr)  Refresh();      
+    return;
+  }
   if (cmap) delete cmap;
   cmap = new PIColorMap(*cmp);
@@ -93,5 +98,8 @@
        (cmap->IsColorIndexReversed() == revidx) &&
        ((vmin-min) < 1.e-69) &&  ((vmin-min) > -1.e-69) &&
-       ((vmax-max) < 1.e-69) &&  ((vmax-max) > -1.e-69) )  return;
+       ((vmax-max) < 1.e-69) &&  ((vmax-max) > -1.e-69) )  { 
+    if (refr)  Refresh();      
+    return;
+  }
   if (cmap) delete cmap;
   cmap = new PIColorMap(cmapid);
@@ -117,9 +125,12 @@
 
   int k;
+  // On limite le nombre de carres de couleurs traces, si trop de couleur ...
+  int dk = cmap->NCol()/128;
+  if (dk<1) dk=1;
   if (sx > sy) {    // horizontal
     int xc, dx;
     xc = 0;
-    for(k=0; k<cmap->NCol(); k++) {
-      dx = (sx-xc)/(cmap->NCol()-k);
+    for(k=0; k<cmap->NCol(); k+=dk) {
+      dx = dk*(sx-xc)/(cmap->NCol()-k);
       g->SelForeground((*cmap), k);
       g->DrawFBox(xc, 0, dx+1, sy);
@@ -130,6 +141,6 @@
     int yc, dy;
     yc = sy;
-    for(k=0; k<cmap->NCol(); k++) {
-      dy = yc/(cmap->NCol()-k);
+    for(k=0; k<cmap->NCol(); k+=dk) {
+      dy = dk*yc/(cmap->NCol()-k);
       yc -= dy;
       g->SelForeground((*cmap), k);
@@ -177,7 +188,103 @@
 }
 
-
-
-
-
-
+//++
+// Class        PICMapDrawer
+// Lib          PI
+// include      picmapview.h
+//
+//      Classe de traceur de colormap 
+//--
+//++
+// Links        Parents
+// PIDrawer
+//--
+//++
+
+
+/* --Methode-- */
+PICMapDrawer::PICMapDrawer(bool fgvert)
+  : fgvert_(fgvert), fgtext_(false), cmapp(NULL), bornes_(5)   
+{
+  SetLimits(0.,1.,0.,1., kAxeDirLtoR, kAxeDirDownUp);
+  SetColMapId(CMAP_GREY32);
+}
+
+/* --Methode-- */
+PICMapDrawer::~PICMapDrawer()
+{
+}
+
+/* --Methode-- */
+void PICMapDrawer::SetBornes(LUT& lut)
+{
+  fgtext_=true;  
+  bornes_[0]=lut.Min();   bornes_[4]=lut.Max(); 
+  bornes_[1]=lut.Borne((lut.NCol()-2)/4);
+  bornes_[2]=lut.Borne((lut.NCol()-2)/2);
+  bornes_[3]=lut.Borne(3*(lut.NCol()-2)/4);
+  return;
+}
+
+/* --Methode-- */
+void PICMapDrawer::SetBornes(double min, double max)
+{
+  fgtext_=true;  
+  bornes_[0]=min;   bornes_[4]=max; 
+  bornes_[1]=min+(max-min)*0.25; 
+  bornes_[2]=min+(max-min)*0.5; 
+  bornes_[3]=min+(max-min)*0.75; 
+  return;
+}
+
+/* --Methode-- */
+void PICMapDrawer::Draw(PIGraphicUC* g, double /*xmin*/, double /*ymin*/, 
+                        double /*xmax*/, double /*ymax*/)
+{
+  PIColorMap* cmp=cmapp;
+  PIColorMap cmapi(cmapid_);
+  if (cmp==NULL)  cmp=&cmapi;
+  PIColorMap& cmap=(*cmp);
+
+  //  cout << " *DBG*PICMapDrawer::Draw() Sz:" << BWdgXSize() << "," << BWdgYSize() 
+  //     << " Pos:" << BWdgXPos() << "," << BWdgYPos() << endl; 
+  // On limite le nombre de carres de couleurs traces, si trop de couleur ...
+  PIPixColIdx pixc;
+  if (fgvert_) {   // vertical
+    pixc.AllocateByte(0.25*BWdgXSize(), BWdgYSize());
+    for(int j=0; j<pixc.YSize(); j++)  {
+      int ci = j*cmap.NCol()/pixc.YSize();
+      int jrev=pixc.YSize()-j-1;
+      for(int i=0; i<pixc.XSize(); i++) pixc.GetByte(i,jrev)=(unsigned char)ci;
+    }
+    g->DrawPixmap(0.,1.,pixc, cmp);
+  }
+  else {    // horizontal
+    pixc.AllocateByte(BWdgXSize(), 0.25*BWdgYSize());
+    for(int i=0; i<pixc.XSize(); i++)  {
+      int ci = i*cmap.NCol()/pixc.XSize();
+      for(int j=0; j<pixc.YSize(); j++) pixc.GetByte(i,j)=(unsigned char)ci;
+    }
+    g->DrawPixmap(0.,0.25,pixc, cmp);
+  }
+
+
+  if (!fgtext_) return;
+  char buff[32];
+  double ps[5]={0.025,0.25,0.5,0.75,0.975};
+  //  g->SelForeground(PI_White);
+  for(int k=0; k<5; k++) {
+    sprintf(buff,"%6.2lg",bornes_[k]);
+    strip(buff,'B',' ');
+    if (fgvert_) {   // vertical
+      g->DrawLine(0.25,ps[k],0.35,ps[k]);
+      g->DrawString(0.7, ps[k], buff, PI_TextDirectionVerticalUp|PI_HorizontalCenter|PI_VerticalCenter);
+    }
+    else {   // horizontal 
+      g->DrawLine(ps[k],0.25,ps[k],0.35);
+      g->DrawString(ps[k], 0.7, buff, PI_VerticalCenter|PI_HorizontalCenter);
+    }
+  }
+  return;
+}
+
+
Index: /trunk/SophyaPI/PI/picmapview.h
===================================================================
--- /trunk/SophyaPI/PI/picmapview.h	(revision 4082)
+++ /trunk/SophyaPI/PI/picmapview.h	(revision 4083)
@@ -11,4 +11,9 @@
 #include PIBWDG_H
 #include PICMAP_H
+
+#include "pidrawer.h"
+#include "lut.h"
+#include <vector>
+
 
 class PICMapView : public PIBaseWdg
@@ -38,4 +43,33 @@
 };
 
+class PICMapDrawer : public PIDrawer
+{
+public:
+                     PICMapDrawer(bool fgvert=false);
+                     ~PICMapDrawer();
+
+  virtual void       Draw(PIGraphicUC* g, double xmin, double ymin, double xmax, double ymax);
+  inline void        SetHorizontal()  { fgvert_=false; }
+  inline void        SetVertical()  { fgvert_=true; }
+
+  inline void        SetColMapId(CMapId cmapid, bool revcidx=false) 
+                     { cmapid_=cmapid;  revcidx_=revcidx;  cmapp=NULL;  return; }
+
+  inline void        SetColMap(PIColorMap* cmp) 
+                     { cmapp=cmp;  return; }
+
+  void               SetBornes(LUT& lut);
+  void               SetBornes(double min, double max);
+
+protected:
+
+  bool fgvert_;  // true -> vertical 
+  bool fgtext_;  // true -> ecriture des valeurs des bornes
+  PIColorMap* cmapp;  
+  CMapId cmapid_;
+  bool revcidx_;  // true -> reverse color map index 
+  vector<double> bornes_;  
+};
+
 
 #endif 
Index: /trunk/SophyaPI/PI/picmapx.cc
===================================================================
--- /trunk/SophyaPI/PI/picmapx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/picmapx.cc	(revision 4083)
@@ -187,4 +187,5 @@
   mColRGB = new PIColor[mNCol];
   mNewCol = new bool[mNCol];
+  /*   Remplace par memcpy pour performances, Reza, Nov 2008
   for (int i=0; i<mNCol; i++)  
     { mColors[i] = ((PIColorMapX *)x)->mColors[i];
@@ -192,3 +193,8 @@
 // C'est la table de couleur originale qui est responsable de liberer les couleurs - Reza 8/2/98
     mNewCol[i] = false; }  
-}
+  -> memcpy (Nov08) */
+  memcpy(mColors, ((PIColorMapX *)x)->mColors, sizeof(PIXColor)*mNCol);
+  memcpy(mColRGB, ((PIColorMapX *)x)->mColRGB, sizeof(PIColor)*mNCol);
+// C'est la table de couleur originale qui est responsable de liberer les couleurs - Reza 8/2/98
+  for (int i=0; i<mNCol; i++)   mNewCol[i] = false;
+}
Index: /trunk/SophyaPI/PI/pidrawer.cc
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pidrawer.cc	(revision 4083)
@@ -52,4 +52,15 @@
 //--
 
+// Valeur par defaut global pour TailleFonteAuto 
+double PIDrawer::glDefAFSzFrac = 0.04;
+void PIDrawer::SetGlDefAutoFontSizeFrac(double fszf)
+{
+  if (fszf>1.e-6)  glDefAFSzFrac = fszf;
+}
+double PIDrawer::GetGlDefAutoFontSizeFrac()
+{
+  return glDefAFSzFrac;
+}
+
 PIDrawer::PIDrawer()
 {
@@ -65,5 +76,5 @@
   limitsFixed = false;
   SetAxesFlags(kAxesNone);   // Pas de trace d'axes par defaut 
-  SetAxesAutoFontSize();
+  ConfigureAutoFontSize(true, glDefAFSzFrac);
 
   mDndfg = false;  // Pour controle de l'appel de Detach() si delete
@@ -107,11 +118,19 @@
 
 //++
-// Titre	Gestion des axes et des limites
+// Titre	Gestion des axes, des limites et coordonnees fenetre
 //      Le tracé des axes 2D est pris en charge par la classe PIAxes.
 //--
 //++
+// double BWdgXPos()  BWdgYPos()
+//	Renvoient les positions (X,Y) du drawer dans l'objet PIBaseWdg. Ces positions ne sont 
+//	valables qu'apres appel a SetDrwWdg() - Ne peut donc etre utilise en pratique que dans 
+//	la methode Draw.
+// double  BWdgXSize()  BWdgYSize()
+//	Renvoient les tailles (X,Y) du drawer dans l'objet PIBaseWdg. Meme remarque que pour 
+//	BWdgXPos()  BWdgYPos(). 
+//
 // void  SetLimits(double xmin, double xmax, double ymin, double ymax, -
 //                 int axrl=kAxeDirSame, int ayud=kAxeDirSame)
-//	Définit les limites du système de coordonnées.
+//	Définit les limites du système de coordonnées du Drawer.
 //|	kAxeDirSame , kAxeDirAuto
 //|	kAxeDirLtoR , kAxeDirRtoL  (Axe X)
@@ -143,12 +162,20 @@
 //|	kMajTicks , kMinTicks , kLabels , kGridOn
 //|	kAxesDflt , kAxesNone
-// void SetAxesAutoFontSize(bool fg=true)
-//	Si "fg==true", la taille de la fonte pour les labels d'axes (chiffres) est 
+// void ConfigureAutoFontSize(bool afsz=true, double fszf=0.05)
+//	Si "fg==true", la taille de la fonte par le drawer, est 
 //	choisie automatiquement, en s'adaptant à la taille de la zone de tracé - 
-//	sinon, taille de la fonte de l'objet PIDrawer.
+//	sinon, taille de la fonte de l'objet PIDrawer. Cette taille est donnée par
+//	FontSize=(YMax()-YMin())*(mFontSzF=fszf). "mFontSzF=fszf" n'est mis à jour
+//	que si fszf>0. Le décodage des attributs graphiques par DecodeOptionString() 
+//	("autofontsize=fszf" et "fixedfontsize")  permet de modifier ces attributs de 
+//	choix automtique de fonte. Utilisé en particulier par PIElDrawer pour 
+//	le tracé les labels d'axes (chiffres).
 // unsigned int GetAxesFlags()
 //	Renvoie les attributs de tracé d'axes  
-// bool  isAxesAutoFontSize()
-//	Renvoie la valeur du flag de choix automatique de taille de fonte pour axes.
+// bool  GetAutoFontSizeState() 
+//	Renvoie la valeur du flag de choix automatique de taille de fonte.
+// double  GetAutoFontSizeFraction()
+//	Renvoie la valeur de la fraction de taille ("mFontSzF) pour lee 
+//	choix automatique de taille de fonte.
 // void  DrawAxes(PIGraphicUC* g)
 //	Méthode de tracé des axes (le tracé est pris en charge par la classe *PIAxes*)
@@ -395,9 +422,30 @@
 PIDrawer::DecodeOptionString(vector<string> & opt, bool rmdecop)
 {
-  if (opt.size() < 1)  return(0);  
+  int nopt0 = opt.size();
+  if (nopt0 < 1)  return(0);  
   PIGraphicAtt gratt;
-  int ndec = gratt.DecodeAttStrings(opt, rmdecop);
+  int ndec1 = gratt.DecodeAttStrings(opt, rmdecop);
   UpdateGraphicAtt(gratt);
-  return(ndec);
+  if ((nopt0 - ndec1) < 1) return(ndec1);  // si tout a ete decode
+  vector<string> udopt;
+  unsigned int k = 0;
+  int ndec = opt.size();
+  string opts;
+  for( k=0; k<opt.size(); k++ ) {
+    opts = opt[k];
+    if (opts.substr(0,13) == "autofontsize=") {
+       double fszf = atof(opts.substr(13).c_str());
+       ConfigureAutoFontSize(true, fszf);
+    }
+    else if (opts == "fixedfontsize")
+       ConfigureAutoFontSize(false, -1.);  
+    else {
+      ndec--;
+      if (rmdecop)  udopt.push_back(opts);
+    }
+  }
+
+  if (rmdecop)  opt = udopt;
+  return(ndec+ndec1); 
 }
 
@@ -424,4 +472,7 @@
   info += "   FontAtt: roman, bold, italic, bolditalic  \n";
   info += "   FontSize: 6,8,10,12... (pts) - integer \n";
+  info += ">>> Automatic font size selection : \n";
+  info += "    autofontsize=FontSizeFrac fixedfontsize \n";
+  info += ">>> ColorTables: defcmap  grey32  invgrey32  colrj32  colbr32 \n";
   info += ">>> marker=MarkerType,MarkerSize (MarkerSize: integer 3,5,7... \n";
   info += "   MarkerType: dot, plus, cross, circle, fcircle, box, fbox \n";
@@ -505,5 +556,5 @@
   PIAxes axes;
   axes.DrawXYAxes(g, mGrAtt, XMin(), XMax(), YMin(), YMax(),
-		  axesFlags, axesAFSz); 
+		  axesFlags, mAFSz, mFontSzF); 
   g->Clip();
 }
Index: /trunk/SophyaPI/PI/pidrawer.h
===================================================================
--- /trunk/SophyaPI/PI/pidrawer.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pidrawer.h	(revision 4083)
@@ -30,5 +30,12 @@
 
   virtual void       SetAxesFlags(unsigned int flags=kAxesNone);
-  inline  void       SetAxesAutoFontSize(bool fg=true) { axesAFSz = fg; }
+
+//---- Choix automatique ou pas de taille de fonte
+  inline void        ConfigureAutoFontSize(bool afsz=true, double fszf=0.04)
+    { mAFSz = afsz;  if (fszf>1e-5)  mFontSzF = fszf; }
+//  Valeur par defaut global pour le AutoFontSizeFrac, utilise dans les constructeurs de PIDrawer
+  static  void       SetGlDefAutoFontSizeFrac(double fszf=0.04);
+//  Retourne la valeur globale par defaut de AutoFontSizeFrac
+  static  double     GetGlDefAutoFontSizeFrac();
 
   virtual void       DrawAxes(PIGraphicUC* g);
@@ -53,4 +60,11 @@
   virtual void	     HighLight(bool fgh);  
 
+  // Zone de trace/accrochage dans le BaseWidget 
+  inline int         BWdgXPos() const { return xW0; }
+  inline int         BWdgYPos() const { return yW0; }
+  inline int         BWdgXSize() const { return xWd; }
+  inline int         BWdgYSize() const { return yWd; }
+
+  // Limites et informations sur les coordonnees dans le systeme du Drawer
   inline double      XMin() const {return xMin;}
   inline double      XMax() const {return xMax;}
@@ -63,5 +77,7 @@
 
   inline unsigned int GetAxesFlags() { return(axesFlags); }
-  inline bool         isAxesAutoFontSize() { return axesAFSz; }
+
+  inline bool         GetAutoFontSizeState() { return mAFSz; }
+  inline double       GetAutoFontSizeFraction() { return mFontSzF; }
 
   inline PIGraphicUC*    GetGraphicUC() { return(mGrUC); }
@@ -127,5 +143,9 @@
   bool limitsFixed;
   unsigned int axesFlags;
-  bool axesAFSz;
+
+  bool mAFSz;  // true -> Choix automatique de taille de font en fraction (ymax-ymin)
+  double mFontSzF;   // TailleFonteAuto = mFontSzF*(ymax-ymin)
+  static double glDefAFSzFrac;   // Valeur globale par defaut pour mFontSzF, utilise ds le constructeur
+
   PIBaseWdgGen* mBWdg;
   PIGraphicUC* mGrUC;
Index: /trunk/SophyaPI/PI/pieldrw.cc
===================================================================
--- /trunk/SophyaPI/PI/pieldrw.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pieldrw.cc	(revision 4083)
@@ -575,7 +575,7 @@
       SetAxesFlags(GetAxesFlags() & ~kMinTicks);
     else if (opts == "extticks")
-      SetAxesFlags(GetAxesFlags() & ~kIntTicks |  kExtTicks);
+      SetAxesFlags((GetAxesFlags() & ~kIntTicks) |  kExtTicks);
     else if (opts == "intticks")
-      SetAxesFlags(GetAxesFlags() & ~kExtTicks |  kIntTicks);
+      SetAxesFlags((GetAxesFlags() & ~kExtTicks) |  kIntTicks);
     else if (opts == "extintticks")
       SetAxesFlags(GetAxesFlags() | kIntTicks |  kExtTicks);
@@ -593,13 +593,5 @@
       }
     }
-
-    else if (opts.substr(0,13) == "autofontsize=") {
-      double fszf = atof(opts.substr(13).c_str());
-      ConfigureAxeAutoFontSize(fszf);
-      SetAxesAutoFontSize(true);
-    }
-    else if (opts == "fixedfontsize")
-      SetAxesAutoFontSize(false);
-
+ 
     else if (opts == "title" || opts == "tit") ShowTitles(true);
     else if (opts == "notitle" || opts == "notit") ShowTitles(false);
@@ -639,6 +631,6 @@
   info += "   ticks/noticks minorticks/nominorticks \n";
   info += "   extticks/intticks/extintticks nbticks=X_NbTicks,Y_NbTicks \n";
-  info += "   tickslen=MajorTickLenFrac,MinorTickLenFraC \n";
-  info += " >> Axe label font size: \n";
+  info += "   tickslen=MajorTickLenFrac,MinorTickLenFraC \n"; 
+  info += " >> Axe labels font size: \n";
   info += "    autofontsize=FontSizeFrac fixedfontsize \n";
   info += " >> Up/Down title: title tit notitle notit \n";
@@ -655,5 +647,5 @@
   //  g->NoClip();
   axeDr.DrawXYAxes(g, mGrAtt, XMin(), XMax(), YMin(), YMax(), 
-		   axesFlags, axesAFSz); 
+		   axesFlags, mAFSz, mFontSzF); 
   if (showAxesLabels) { 
     axeDr.DrawXCaption(g, labelAtt, axesFlags, xLabel);
Index: /trunk/SophyaPI/PI/pieldrw.h
===================================================================
--- /trunk/SophyaPI/PI/pieldrw.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pieldrw.h	(revision 4083)
@@ -246,6 +246,4 @@
 				       double majtl=0., double mintl=0.)
      { axeDr.ConfigureTicks(ntickx, nticky, majtl, mintl); }
-  inline void        ConfigureAxeAutoFontSize(double fszf=0.)
-     { axeDr.ConfigureAutoFontSize(fszf); }
 
   inline PIElDrwMgr& ElDrwMgr()    { return eltsMgr; }
Index: /trunk/SophyaPI/PI/pifilechox.cc
===================================================================
--- /trunk/SophyaPI/PI/pifilechox.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pifilechox.cc	(revision 4083)
@@ -120,5 +120,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate((char *)path.c_str(), XmSTRING_DEFAULT_CHARSET);
+xmstr = XmStringLtoRCreate(const_cast<char*>(path.c_str()), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
 Arg warg[2];
 XtSetArg(warg[0], XmNdirectory, xmstr); 
@@ -132,5 +132,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate((char *)fname.c_str(), XmSTRING_DEFAULT_CHARSET);
+xmstr = XmStringLtoRCreate(const_cast<char*>(fname.c_str()),  const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
 Arg warg[2];
 XtSetArg(warg[0], XmNtextString, xmstr); 
Index: /trunk/SophyaPI/PI/pifontx.cc
===================================================================
--- /trunk/SophyaPI/PI/pifontx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pifontx.cc	(revision 4083)
@@ -263,19 +263,24 @@
 
 static XtResource resources[] = {
-  { "fontFamilyName", "FontFamilyName", XtRString, sizeof(String),
+  { const_cast<char *>("fontFamilyName"), const_cast<char *>("FontFamilyName"), 
+    XtRString, sizeof(String),
     /*XtOffset(apd, fntFam[0])*/ 0, XtRString, const_cast<char *>("*-courier") } ,
-  { "courierfontFamilyName", "CourierfontFamilyName", XtRString, sizeof(String),
+  { const_cast<char *>("courierfontFamilyName"), const_cast<char *>("CourierfontFamilyName"), 
+    XtRString, sizeof(String),
     sizeof(String) , XtRString, const_cast<char *>("*-courier") } ,
-  { "helveticafontFamilyName", "HelveticafontFamilyName", XtRString, sizeof(String),
+  { const_cast<char *>("helveticafontFamilyName"), const_cast<char *>("HelveticafontFamilyName"), 
+    XtRString, sizeof(String),
     2*sizeof(String) , XtRString, const_cast<char *>("*-helvetica") } ,
-  { "timesfontFamilyName", "TimesfontFamilyName", XtRString, sizeof(String),
+  { const_cast<char *>("timesfontFamilyName"), const_cast<char *>("TimesfontFamilyName"), 
+    XtRString, sizeof(String),
     3*sizeof(String) , XtRString, const_cast<char *>("*-times") } ,
-  { "symbolfontFamilyName", "SymbolfontFamilyName", XtRString, sizeof(String),
+  { const_cast<char *>("symbolfontFamilyName"), const_cast<char *>("SymbolfontFamilyName"), 
+    XtRString, sizeof(String),
     4*sizeof(String) , XtRString, const_cast<char *>("*-symbol") }
 };
  
-static char * fnbi_b[4] = { "medium-r-normal", "bold-r-normal", 
+static const char * fnbi_b[4] = { "medium-r-normal", "bold-r-normal", 
                           "medium-o-normal", "bold-o-normal" };
-static char * fnbo_b[4] = { NULL, NULL, 
+static const char * fnbo_b[4] = { NULL, NULL, 
                           "medium-i-normal", "bold-i-normal" };
 
@@ -289,31 +294,44 @@
   int count,k;
   Display * mdsp = PIXDisplay();
-  char **list;
+  char **list = NULL;
 
   for (k=0; k<5; k++)  {  // Recherche de la fonte pour tailles croissantes
     sprintf(buff,"-%s-%s-*-%d-*-*-*-*-*-*-*", apd.fntFam[kfn], fnbi_b[jat], fntsz[isz]+k);
     list = XListFonts(mdsp, buff, 10, &count);
-    XFreeFontNames(list);
     if ((count <= 0) && (fnbo_b[jat] != NULL)) {
+      if (list) XFreeFontNames(list);  
       sprintf(buff,"-%s-%s-*-%d-*-*-*-*-*-*-*", apd.fntFam[kfn], fnbo_b[jat], fntsz[isz]+k);
       list = XListFonts(mdsp, buff, 10, &count);
-      XFreeFontNames(list);
     }
     if (count > 0)  break;
-    }
+  }
   // certaines fontes n'ont pas de version  bold ou italique
   if ( (count == 0) && (jat > 0) ) {
     for (k=0; k<5; k++)  {  // Recherche de la fonte pour tailles croissantes
+      if (list) XFreeFontNames(list);  
       sprintf(buff,"-%s-%s-*-%d-*-*-*-*-*-*-*", apd.fntFam[kfn], fnbi_b[0], fntsz[isz]+k);
       list = XListFonts(mdsp, buff, 10, &count);
-      XFreeFontNames(list);
       if (count > 0)  break;
-      }
     }
-  if (count > 0) 
-    fntst[isz][jat][kfn] = XLoadQueryFont(mdsp, buff);
-  else
-    { printf("PIFontX::LoadFontSt/ Pb font %s - Using default \n", buff);    
-    fntst[isz][jat][kfn] = defnt; }
+  }
+  if (count > 0) {
+    for (int kkk=0; kkk<count; kkk++) {
+      /*  pour debug 
+      printf("PIFontX::LoadFontSt/DBG - Call to XLoadFont(%s) \n", list[kkk]);
+      Font lfid=XLoadFont(mdsp,list[kkk]);
+      printf("PIFontX::LoadFontSt/DBG - Call to XQueryFont(FID=%ld) \n", (unsigned long)lfid); 
+      fntst[isz][jat][kfn] = XQueryFont(mdsp, lfid);   
+      printf("PIFontX::LoadFontSt/DBG - Call to XLoadQueryFont(%s) \n", list[kkk]); 
+      */
+      fntst[isz][jat][kfn] = XLoadQueryFont(mdsp, list[kkk]);
+      if (fntst[isz][jat][kfn] != NULL) break;
+    }
+    if (list) XFreeFontNames(list);  
+  }
+  else  { 
+    if (list) XFreeFontNames(list);  
+    printf("PIFontX::LoadFontSt/ Pb font %s - Using default \n", buff);    
+    fntst[isz][jat][kfn] = defnt; 
+    }
   }
 
@@ -342,37 +360,47 @@
 XtGetApplicationResources(PIXtTopWdg(), &apd, resources, 
                           XtNumber(resources), NULL, 0);
+// printf("PIFontX::GlInit()-DBG- FontFamily = %s \n",apd.fntFam[0]);
+
 sprintf(buff,"-%s-*-*-*-*-*-*-*-*-*-*-*-*", apd.fntFam[0]);
+list = NULL;
 list = XListFonts(mdsp, buff, 15, &count);
-XFreeFontNames(list);
 if (count < 5)
   { 
   printf("PIFontX::Init %d fonts found for %s , switching to courier\n",
          count, apd.fntFam[0]);
-  apd.fntFam[0] = "*-courier";
+  apd.fntFam[0] = const_cast<char *>("*-courier");
+  if (list) XFreeFontNames(list);
   }
 sprintf(buff,"-%s-%s-*-*-*-*-12-*-*-*-*", apd.fntFam[0], fnbi_b[0]);
 list = XListFonts(mdsp, buff, 10, &count);
-XFreeFontNames(list);
 if (count < 1) {
+  if (list) XFreeFontNames(list);
   sprintf(buff,"-*-fixed-*-*-*-*-12-*-*-*-*-*-*-*");
   list = XListFonts(mdsp, buff, 10, &count);
-  XFreeFontNames(list);
   if (count < 1)   {  
+    if (list) XFreeFontNames(list);
     sprintf(buff,"fixed");
     list = XListFonts(mdsp, buff, 10, &count);
-    XFreeFontNames(list);
   }
   if (count < 1)   {  
+    if (list) XFreeFontNames(list);
     strcpy(buff,"");
     list = XListFonts(mdsp, buff, 10, &count);
-    XFreeFontNames(list);
   }
 }
 if (count < 1) {  
+  if (list) XFreeFontNames(list);
   printf("PIFontX::Init/ Erreur, no font found ... \n");
   defnt = NULL;
-  }
-else defnt = XLoadQueryFont(mdsp, buff);
-
+  //Reza+Bruno, 17 Juin 2008 - Il faut lancer une exception 
+  }
+else { 
+  defnt = NULL;
+  for (int kkk=0; kkk<count; kkk++) {
+    defnt = XLoadQueryFont(mdsp, list[kkk]);
+    if (defnt != NULL) break;
+  }
+  if (list) XFreeFontNames(list);  
+}
 for (i=0; i<NMAXFONTSZ; i++)
   for (j=0; j<NMAXFONTATT; j++)  
@@ -399,6 +427,6 @@
 // HugeFontIndex = NMAXFONTSZ-1;
 
-// printf("PIFontX::Init()-DBG- FontIndex= %d %d %d (SzF=%d) \n", 
-//       SmallFontIndex, NormalFontIndex, BigFontIndex, szf);
+// printf("PIFontX::GlInit()-DBG- FontIndex= %d %d %d (SzF=%d) \n", 
+//       SmallFontIndex, NormalFontIndex, HugeFontIndex, szf);
 
 return;
Index: /trunk/SophyaPI/PI/pigraphgen.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphgen.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphgen.h	(revision 4083)
@@ -17,4 +17,5 @@
 
 #include "pilineatt.h"  // Class PILineAtt
+#include "pipixutils.h"  // classes utilitaires pour pixels/RGB ...
 
 
@@ -118,6 +119,6 @@
 				     bool fgline=true);
 
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap)              = 0;
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, 
+                                PIColorMap* cmap)                              = 0;
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphps.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphps.cc	(revision 4083)
@@ -324,11 +324,16 @@
 
 /* --Methode-- */
-void PIGraphicPS::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                            int sx, int sy, PIColorMap* cmap)
-{
+void PIGraphicPS::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pixc, PIColorMap* cmap) 
+{
+int sx = pixc.XSize();
+int sy = pixc.YSize();
 if ( (sx < 1) || (sy < 1) )  return;
-if ((pix == NULL) || (cmap == NULL)) return;
-if(mPSOut) 
-  mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pix, cmap);
+if (cmap == NULL) return;
+if(mPSOut) {
+  if (pixc.BytePointer()) 
+    mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pixc.BytePointer(), cmap);
+  else if (pixc.ShortPointer()) 
+    mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pixc.ShortPointer(), cmap);
+}
 return;
 }
